function DOMParser () {
	this.parseFromString = function(string,type) 
	{
		return new com.lava.parsers.XMLDocument(string);
	}
}

function XMLHttpRequest() {
	
		this.headers = {};
		this.responseHeaders = {};
		this.curLocation = (new java.io.File("./")).toURL();	
		this.open = function(method, url, async){ 
			this.readyState = 1;
			//we take care of threading at java level
			/*
			if (async)
				this.async = true;
			*/
			this.method = method || "GET";
			this.url = url;
			this.onreadystatechange();
	
	}, 
		
		this.setRequestHeader = function(header, value){
			this.headers[header] = value;
		},
		this.getResponseHeader = function(header){ },
		this.send = function(data){
			var self = this;
			
			function makeRequest(){
				var url = new java.net.URL(self.curLocation, self.url);
				
				if ( url.getProtocol() == "file" ) {
					if ( self.method == "PUT" ) {
						var out = new java.io.FileWriter( 
								new java.io.File( new java.net.URI( url.toString() ) ) ),
							text = new java.lang.String( data || "" );
						
						out.write( text, 0, text.length() );
						out.flush();
						out.close();
					} else if ( self.method == "DELETE" ) {
						var file = new java.io.File( new java.net.URI( url.toString() ) );
						file["delete"]();
					} else {
						var connection = url.openConnection();
						connection.connect();
						handleResponse();
					}
				} else { 
					/**
					 * TODO: fill these variables properly
					 */
					var str = com.lava.utils.LavaUtils.downloadFileFromInternet(self.url);
					if(str == null)
					{
						self.status = 404;
						self.statusText = "Not found";
						self.responseText = "";
					}
					else
					{
						self.responseText += str;
						self.status = 200;
						self.statusText = "OK";
					}
					self.readyState = 4;
					
					/*
					var connection = url.openConnection();
					
					connection.setRequestMethod( self.method );
					
					// Add headers to Java connection
					for (var header in self.headers)
						connection.addRequestProperty(header, self.headers[header]);
				
					try {
					connection.connect();
					for (var i = 0; ; i++) { 
						var headerName = connection.getHeaderFieldKey(i); 
						var headerValue = connection.getHeaderField(i); 
						if (!headerName && !headerValue) break; 
						if (headerName)
							self.responseHeaders[headerName] = headerValue;
					}
					
					handleResponse();
					} catch (e) {}
					// Stick the response headers into responseHeaders
					*/
					
				}
				
				function handleResponse(){
					self.readyState = 4;
					self.status = parseInt(connection.responseCode) || undefined;
					self.statusText = connection.responseMessage || "";
					
					var stream = new java.io.InputStreamReader(connection.getInputStream()),
						buffer = new java.io.BufferedReader(stream), line;
					
					while ((line = buffer.readLine()) != null)
						self.responseText += line;
				}
				
				self.onreadystatechange();
			}

			if (this.async) {
                                var th = new java.lang.Thread(makeRequest);
				th.setDaemon(true);
				th.start();
                        }
				//(new java.lang.Thread(new java.lang.Runnable({
				//	run: makeRequest
				//}))).start();
			else
				makeRequest();
		},
		this.abort = function(){},
	
		this.onreadystatechange = function(){},
		
		this.getResponseHeader = function(header){
			if (this.readyState < 3)
				throw new Error("INVALID_STATE_ERR");
			else {
				var returnedHeaders = [];
				for (var rHeader in this.responseHeaders) {
					if (rHeader.match(new Regexp(header, "i")))
						returnedHeaders.push(this.responseHeaders[rHeader]);
				}
			
				if (returnedHeaders.length)
					return returnedHeaders.join(", ");
			}
			
			return null;
		},
		this.getAllResponseHeaders = function(header){
			if (this.readyState < 3)
				throw new Error("INVALID_STATE_ERR");
			else {
				var returnedHeaders = [];
				
				for (var header in this.responseHeaders)
					returnedHeaders.push( header + ": " + this.responseHeaders[header] );
				
				return returnedHeaders.join("\r\n");
			}
		},
		this.async = false,
		this.readyState = 0,
		this.responseText = "",
		this.status = 0
			
}


var JSON = {

parse: function (json) {
		return OFusion.JSONParse(json);
	}

};
